#include <MeshDataBaseForTests.hpp>
#include <utils/PugsAssert.hpp>

#include <mesh/CartesianMeshBuilder.hpp>

const MeshDataBaseForTests* MeshDataBaseForTests::m_instance = nullptr;

MeshDataBaseForTests::MeshDataBaseForTests()
{
  std::make_shared<CartesianMeshBuilder>(TinyVector<3>{0, 1, 0}, TinyVector<3>{2, -1, 3},
                                         TinyVector<3, size_t>{6, 7, 3});
}

const MeshDataBaseForTests&
MeshDataBaseForTests::get()
{
  return *m_instance;
}

void
MeshDataBaseForTests::create()
{
  Assert(m_instance == nullptr);
  m_instance = new MeshDataBaseForTests();
}

void
MeshDataBaseForTests::destroy()
{
  Assert(m_instance != nullptr);
  delete m_instance;
  m_instance = nullptr;
}
